<template>
  <main>
    <v-container>
      <v-layout row>
        <v-flex sm12>
          <v-card>
            <v-card-title primary-title>
              <div>
                <div class="headline">Merchant Management</div>
                <div class="grey--text">Lorem ipsum dolor sit amet.</div>
              </div>
              <v-spacer></v-spacer>
              <add-merchant />
            </v-card-title>
            <!-- Card Content -->
            <v-data-table :headers="headers" :items="items" :search="search" :loading="loading" :rows-per-page-items="[50, 100, 500]">
              <template slot="items" scope="props">
                <tr @click="merchant(props.item.id)">
                  <td>{{props.item.courtName}}</td>
                  <td>{{props.item.location}}</td>
                </tr>
              </template>
            </v-data-table>
          </v-card>
        </v-flex>
      </v-layout>
    </v-container>
  </main>
</template>

<script>
  import AddMerchant from '@/components/add-merchant'
  export default {
    name: 'merchants',
    components: {AddMerchant},
    data () {
      return {
        loading: true,
        search: null,
        headers: [
          { text: 'Court Name', value: 'courtName', align: 'left' },
          { text: 'Location', value: 'location', align: 'left' }
        ],
        items: [],
        db: this.$database.ref('merchants')
      }
    },
    methods: {
      merchant (id) { this.$router.push({path: `merchant/${id}`}) },
      loadMerchants (ref) {
        ref.once('value').then(snapshot => {
          let merchants = snapshot.val()

          if (merchants) {
            Object.keys(merchants).forEach(merchant => {
              merchants[merchant].id = merchant
              this.items.push(merchants[merchant])
            })
          }

          this.loading = false
        })
      }
    },
    created () {
      /*
       * You can extend this with queries
       * https://firebase.google.com/docs/database/web/lists-of-data#sorting_and_filtering_data
       * Example: this.db.orderByChild('propName')
       */
      let ref = this.db
      this.loadMerchants(ref)
    }
  }
</script>
